#!/bin/sh
#
# Unpacks a user archive and restore it (except for the user credentials)
#
# @version 1 (15.11.2011) florian.faber@directout.eu
#            - initial version
#
# Exit values:
#   0 - OK
#   1 - Empty parameter
#   2 - User directory not found
#   3 - File not found
#

if [ $# -ne 3 ]
then
  echo "Usage: $0 <uid> <upgrade file> <boundary>"
  exit 1
fi

if [ ! -d /user/$1 ]
then
  echo "User directory '/user/$1' not found."
  exit 2
fi

if [ ! -f $2 ]
then
  echo "File '$2' not found."
  exit 3
fi

#trap "rm -rf /tmp/upgrade" 0

if [ ! -d /ftmp ]
then
  mkdir /ftmp
fi


TMPDIR=/ftmp/user_$1

mkdir $TMPDIR

/system/multipart_extract $2 file $3 | bzip2 -d | tar -xo -C $TMPDIR

rm $2

rm $TMPDIR/user $TMPDIR/user.old $TMPDIR/user.old2 || true
cp /user/$1/user* $TMPDIR

rm -rf /user/$1

mv $TMPDIR /user/$1

sync

exit 0
