/**
 * M1k2 channel dialog
 * (c) D.O.Tec, http://www.directout.eu
 * @version 1 (21.11.2010) Florian Faber, florian.faber@directout.eu
 **/


channeldialog_selectioncnt = 0;
channeldialog_selection = 0;
channeldialog_left = 220;
channeldialog_top = 220;


function channeldialog_routingmsg(msg) {
  var o = document.getElementById("routingmsg");
  o.innerHTML = msg;
}


dragX = 0;
dragY = 0;
dragD = null;

function channeldialog_dragmove(e) {
  var x, y;

  x = e.clientX + window.scrollX - dragX;
  y = e.clientY + window.scrollY - dragY;

  dragD.style.left = x+"px";
  dragD.style.top = y+"px";

  channeldialog_top = e.clientY-dragY;
}

function channeldialog_dragstop() {
 document.removeEventListener("mousemove", channeldialog_dragmove, true);
 document.removeEventListener("mouseup", channeldialog_dragstop , true);
}

function channeldialog_dragstart(e) {
  dragD = document.getElementById("channeldialog");

  dragX = e.clientX + window.scrollX - dragD.offsetLeft;
  dragY = e.clientY + window.scrollY - dragD.offsetTop;

  document.addEventListener("mousemove", channeldialog_dragmove, true);
  document.addEventListener("mouseup", channeldialog_dragstop, true);
}


function channeldialog_tab(idx) {
  var o, i;

  for (i=1; i<=3; i++) {
    o = document.getElementById("tab"+i);
    if (i==idx) {
      o.style.display='block';
    } else {
      o.style.display='none';
    }
    o = document.getElementById("tabtitle"+i);
    if (i==idx) {
      o.className = 'active';
    } else {
      o.className = '';
    }
  }
}

function channeldialog_addport(port, name, bgcolor, color, type) {
  var o = document.getElementById("routingportlist");
  var ch = document.createElement("div");
  ch.className = 'routinglistentry';
  if (bgcolor) ch.style.backgroundColor = "#"+bgcolor;
  if (color) ch.style.color = color;
  ch.innerHTML = name;
  ch.id = "rdp"+port;
  ch.onclick = function(ev){ channeldialog_portselected(ch, port, type); };

  o.appendChild(ch);
}


function channeldialog_clearports() {
  var o = document.getElementById("routingportlist");
  while (o.hasChildNodes()) {
    o.removeChild(o.lastChild);
  }
}


function channeldialog_clearchannels() {
  var o = document.getElementById("routingchannellist");
  while (o.hasChildNodes()) {
    o.removeChild(o.lastChild);
  }

  channeldialog_selectedchannel = null;
}


function channeldialog_rebuildports() {
  var i;

  channeldialog_clearports();

  for (i=0; i<16; i++) {
    if (src_ports[i]==1) {
      channeldialog_addport(i+1, src_port_names[i], null, null, 1);
    }
  }

  for (i=0; i<channelgroup_names.length; i++) {
    channeldialog_addport(i, channelgroup_names[i], channelgroup_colors[i], 'fff', 2);
  }
  
}


/**
 * @param tab 1=route, 2=group
 **/
function channeldialog_open(tab, channelselection, selectioncnt) {
  var o = document.getElementById("channeldialog");
  if (o.style.display=="block") return;

  channeldialog_selectioncnt = selectioncnt;
  channeldialog_selection = channelselection;
  
  channeldialog_rebuildports();
  channeldialog_clearchannels();
  
  channeldialog_routingmsg("");
  
  channeldialog_tab(tab);

  o.style.top = (channeldialog_top+window.scrollY)+"px";
  o.style.display = "block";

  dialog_active = true;
}



function channeldialog_inspector_addchannel(port, channel, name, bgcolor, color, type) {
  var o = document.getElementById("inspectorchannellist");
  var ch = document.createElement("div");
  ch.className = 'routinglistentry';
  if (bgcolor) ch.style.backgroundColor = bgcolor;
  if (color) ch.style.color = color;
  ch.innerHTML = name;
  ch.id = "rdch"+channel;
  ch.onclick = function(ev){ channeldialog_inspector_select(ev, ch, port, channel, type); };

  o.appendChild(ch);
}

function channeldialog_inspector(sourcechannel, sinkchannels) {
  var o = document.getElementById("channeldialog");
  if (o.style.display=="block") return;

  channeldialog_tab(3);

  o.style.display = "block";
  
  var o = document.getElementById("inspectorchannellist");
  while (o.hasChildNodes()) {
    o.removeChild(o.lastChild);
  }

  o = document.getElementById("inspectorinput");
  o.innerHTML = src_names[sourcechannel];

  for (var i=0; i<sinkchannels.length; i++) {
    channeldialog_inspector_addchannel(Math.floor(sinkchannels[i]/64), sinkchannels[i]%64, dest_names[sinkchannels[i]], null, null, 1);
  }

  dialog_active = true;
}


function channeldialog_close() {
  var o = document.getElementById("channeldialog");
  o.style.display = "none";
  document.addEventListener('keydown', key_handler, true);  

  dialog_active = false;
}


channeldialog_selectedchannel = null;
channeldialog_selectedchannel_bg = null;
channeldialog_selectecchannel_c = null;
channeldialog_selectedchannel_type = null;
channeldialog_selectedchannel_id = null;
channeldialog_selectedchannel_offset = null;


function channeldialog_routing_apply() {
  if (!channeldialog_selectedchannel) {
    alert(channeldialog_err_no_channel_selected);
    return;
  }

  channeldialog_close();

  // submit routing
}



function channeldialog_channelclicked(ev, o, id, offset, type) {
  var i, node;

  if (channeldialog_selectedchannel) {
    channeldialog_selectedchannel.style.backgroundColor = channeldialog_selectedchannel_bg;
    channeldialog_selectedchannel.style.color = channeldialog_selectedchannel_c;

    i = channeldialog_selectioncnt-1;
    node = channeldialog_selectedchannel.nextElementSibling;
    while ((i>0) && node) {
      if (type==1) {
	node.style.backgroundColor = "#fff";
      } else {
	node.style.opacity = 1;
      }
      node = node.nextElementSibling;
      i--;
    }
  }

  channeldialog_selectedchannel = o;
  channeldialog_selectedchannel_bg = o.style.backgroundColor;
  channeldialog_selectedchannel_c = o.style.color;

  if (type==1) {
    o.style.backgroundColor = "#666";
    o.style.color = "#fff";
  } else if (type==2) {
    o.style.backgroundColor = "#fff";
    o.style.color = "#000";
  }

  channeldialog_selectedchannel_type = type;
  channeldialog_selectedchannel_id = id;
  channeldialog_selectedchannel_offset = offset;

  i = channeldialog_selectioncnt-1;
  node = o.nextElementSibling;
  while ((i>0) && node) {
    if (type==1) {
      node.style.backgroundColor = "#bbb";
    } else if (type==2) {
      node.style.opacity = 0.5;
    }
    node = node.nextElementSibling;
    i--;
  }

  if (i>0) {
    if (type==1) {
      if ((id-1)*64+offset+selectioncnt>1024) {
	channeldialog_routingmsg(channeldialog_warn_portchannel_truncation);
      } else {
	channeldialog_routingmsg(channeldialog_warn_portchannel_border);
      }
    } else if (type==2) {
      channeldialog_routingmsg(channeldialog_warn_groupchannel_truncation);
    }
  } else {
    channeldialog_routingmsg("");
  }
}


function channeldialog_addchannel(port, channel, name, bgcolor, color, type) {
  var o = document.getElementById("routingchannellist");
  var ch = document.createElement("div");
  ch.className = 'routinglistentry';
  if (bgcolor) ch.style.backgroundColor = bgcolor;
  if (color) ch.style.color = color;
  ch.innerHTML = name;
  ch.id = "rdch"+channel;
  ch.onclick = function(ev){ channeldialog_channelclicked(ev, ch, port, channel, type); };

  o.appendChild(ch);
}


channeldialog_selectedport = null;
channeldialog_selectedorigbg = null;
channeldialog_selectedorigcolor = null;


function channeldialog_portselected(entry, id, t) {
  //alert("channeldialog_portselected("+id+", "+t+")");
  channeldialog_clearchannels();

  if (channeldialog_selectedport) {
    channeldialog_selectedport.style.backgroundColor = channeldialog_selectedorigbg;
    channeldialog_selectedport.style.color = channeldialog_selectedorigcolor;
  }

  channeldialog_selectedorigcolor = entry.style.color;
  channeldialog_selectedorigbg = entry.style.backgroundColor;
  channeldialog_selectedport = entry;

  //  entry.style.border = "2px solid black";
  entry.style.backgroundColor = "#666";
  entry.style.color = "#fff";

  channeldialog_routingmsg("");

  if (t==1) {
    for (var i=0; i<64; i++) {
      channeldialog_addchannel(id, i+1, src_names[(id-1)*64+i], null, '000', 1);
    }

    if ((id-1)*64+selectioncnt>1024) {
      channeldialog_routingmsg(channeldialog_warn_port_truncation);
    } else if (channeldialog_selectioncnt>64) {
      channeldialog_routingmsg(channeldialog_warn_port_border);
    }

  } else if (t==2) {
    for (var i=0; i<src_group_channels[id].length; i++) {
      channeldialog_addchannel(Math.floor(src_group_channels[id][i]/64), src_group_channels[id][i]%64, group_channelnames[id][src_group_channels[id][i]], "#"+channelgroup_colors[id], '#fff', 2);
    }
    
    if (src_group_channels[id].length<channeldialog_selectioncnt) {
      channeldialog_routingmsg(channeldialog_warn_group_truncation);
    }
  }

}
