fan_drag_object = null;
fan_drag_y=0;
fan_drag_min=0;
fan_drag_max=0;
fan_drag_offset=0;
fan_drag_type = 0;
t_slow = 0;
t_full = 0;
t_critical = 0;


function fan_drag_off() {
	if (fan_drag_object != null) {
		send_cmd("fan?"+Math.round(t_slow)+","+Math.round(t_full)+","+Math.round(t_critical));
		fan_drag_object = null;
	}  
}

function fan_drag(e) {
	if (!fan_drag_object)
		return;
	
	var o = document.getElementById('fangraph');
	var x = (e.clientX-70-o.offsetLeft)/4-6;
  
	if (x<fan_drag_min)
		x = fan_drag_min;
	else if (x>fan_drag_max)
		x = fan_drag_max;
	
	switch (fan_drag_type) {
	case 1:
		t_slow = x; break;
	case 2:
		t_full = x; break;
	case 3:
		t_critical = x; break;
	} 
	
	update_fangraph(t_slow, t_full, t_critical);
	
	fan_drag_object.style.left = (70+x*4-6)+"px";
	fan_drag_object.style.top = fan_drag_y+"px";
}


function update_fangraph(slow, full, critical) {
	t_slow = slow;
	t_full = full;
	t_critical = critical;
	
	var fan_slow = document.getElementById('fan_slow');
	if (!fan_slow)
		return;

	var fan_full = document.getElementById('fan_full');
	var fan_critical = document.getElementById('fan_critical');
	
	fan_slow.style.left = (70+slow*4-6)+"px";
	fan_slow.style.top = "212px";
	fan_full.style.left = (70+full*4-6)+"px";
	fan_full.style.top = "12px";
	fan_critical.style.left = (70+critical*4-6)+"px";
	fan_critical.style.top = "12px";
	
	var canvas = document.getElementById('fancanvas');
	var context = canvas.getContext('2d');
	canvas.width = canvas.width; // clear
	context.strokeStyle = "rgb(210, 150, 64)";
	context.beginPath();
	context.moveTo(0, 200);
	context.lineTo(slow*4, 200);
	context.lineTo(full*4, 0);
	context.lineTo(360, 0);
	context.stroke();
} 


function update_fantemp(temp, pwm) {
	var o = document.getElementById('fan_current');
	o.style.left = (70+temp*4-6)+"px";
	o.style.top = (12+(100-pwm)*2)+"px";
} 

function c_to_f(c) { return c*9/5+32; }

function f_to_c(f) { return (f-32)*5/9; }

function min(a, b) { return (a<b)?a:b; }

function max(a, b) { return (a<b)?b:a; }

function check_tf(tf, mi, max) {
	if ((tf.value>=mi) && (tf.value<=max))
		return true;

	tf.style.background = 'red';
	return false;
}

function check_input_c() {
	return check_tf(document.getElementById("temp_slow"), 0, min(60, t_full-1)) &&
		check_tf(document.getElementById("temp_full"), t_slow+1, min(75, t_critical-1)) &&
		check_tf(document.getElementById("temp_critical"), t_full+1, 90);
}

function check_input_f() {
	return check_tf(document.getElementById("temp_slow_f"), 32, min(140, c_to_f(t_full)-1)) &&
		check_tf(document.getElementById("temp_full_f"), c_to_f(t_slow)+1, min(167, c_to_f(t_critical)-1)) &&
		check_tf(document.getElementById("temp_critical_f"), c_to_f(t_full)+1, 194);
}


function tempc_changed() {
	if (check_input_c()) 
		send_cmd("fan?"+Math.round(document.getElementById('temp_slow').value)+","+Math.round(document.getElementById('temp_full').value)+","+Math.round(document.getElementById('temp_critical').value));
}

function tempf_changed() {
	if (check_input_f())
		send_cmd("fan?"+Math.round(f_to_c(document.getElementById('temp_slow_f').value))+","+Math.round(f_to_c(document.getElementById('temp_full_f').value))+","+Math.round(f_to_c(document.getElementById('temp_critical_f').value)));
}

// EventSource callbacks
function ess_temp(temp) {
  temp = Math.floor(temp/100)/10;
  update_fantemp(temp, parent.frames[0].status_fan);
  document.getElementById('tempc_current').innerHTML = temp+"&deg;C";
  document.getElementById('tempf_current').innerHTML = Math.round(c_to_f(temp))+"&deg;F";
}

function ess_fan(speed) {
  update_fantemp(parent.frames[0].status_temp, speed);
}

function esc_fan(slow, full, critical) {
  update_fangraph(slow, full, critical);
  document.getElementById('temp_slow').value = slow;
  document.getElementById('temp_slow').style.background = 'white';
  document.getElementById('temp_slow_f').value = Math.round(c_to_f(slow));
  document.getElementById('temp_slow_f').style.background = 'white';
  document.getElementById('temp_full').value = full;
  document.getElementById('temp_full').style.background = 'white';
  document.getElementById('temp_full_f').value = Math.round(c_to_f(full));
  document.getElementById('temp_full_f').style.background = 'white';
  document.getElementById('temp_critical').value = critical;
  document.getElementById('temp_critical').style.background = 'white';
  document.getElementById('temp_critical_f').value= Math.round(c_to_f(critical));
  document.getElementById('temp_critical_f').style.background = 'white';
}
