
function update_system_scripts(response) {
    var data = JSON.parse(response);
    for (var id=0; id<64; id++) {
	var o = document.getElementById("script_"+id);
	var t = document.getElementById("script_title_"+id);
	var u = document.getElementById("f_up_"+id);
	var d = document.getElementById("f_del_"+id);
	
        if (data[id]) {
	    o.style.backgroundColor = data[id]["bg"];
	    o.style.color = data[id]["fg"];
	    o.title = "#"+(id+1)+": "+data[id]["desc"];
	    o.onclick = dl_script;
	    t.innerHTML = data[id]["name"];
	    u.innerHTML = "Change..";
	    d.style.display = "inline-block";									
	} else {
	    o.style.backgroundColor = "#ddd";
	    o.style.color = "#000";
	    o.title = "[#"+(id+1)+" EMPTY]";
	    o.onclick = null;
	    t.innerHTML = "[#"+(id+1)+" EMPTY]";
	    u.innerHTML = "Upload..";
	    d.style.display = "none";									 
	}
    }
}

function create_button(id) {
    var s = document.createElement("div");
    s.id = "script_"+id;							
    s.className = 'scriptbutton';
    s.scriptid = id;
    
    s.innerHTML = "<form action='/data/system_script?"+id+"' method='post' enctype='multipart/form-data' id='f_script_"+id+"'><label id='f_label_"+id+"'><input class='f_hidden' type='file' name='script' id='script_"+id+"' onchange='submit();'><div id='f_up_"+id+"' class='scriptupload'>Upload..</div></label></form><div class='scriptdel' style='display: none;' id='f_del_"+id+"' onclick=\"event.stopPropagation(); if (confirm('Are you sure to delete this script?')) ajax_call('/data/system_script_del?"+id+"');\">Delete</div><div class='script_title' id='script_title_"+id+"'></div>";
    return s;
}

function init_table() {
    var container = document.getElementById('system_scripts');
    while (container.hasChildNodes())
	container.removeChild(container.firstChild);

    for (i=0; i<64; i++) {
	container.appendChild(create_button(i));
    }

    ajax_call('/data/system_scripts', update_system_scripts);											
}

function dl_script(e) {
    var srcElement;
    
    if (e.srcElement) {
	srcElement = e.srcElement;
    } else if (e.originalTarget) {
	srcElement = e.originalTarget;
    }		

    if (typeof(srcElement.scriptid)=="undefined")
	srcElement = srcElement.parentElement;

    if (typeof(srcElement.scriptid)!="undefined") {
	window.open('/data/system_script?'+srcElement.scriptid, 'scriptsource', 'location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,toolbar=no,height=600,width=700');
    }
}

function esc_plugin_perms(pluginid, permissionid) {
    var s = document.getElementById('pp_'+pluginid);
    if (s)
	set_selectactive(s, permissionid);
}

function esc_plugin_active(pluginid, status) {
    var s = document.getElementById('cb_'+pluginid);
    if (s) {
	s.checked = (status==1);
    }
}

function system_scripts_updated() {
    ajax_call('/data/system_scripts', update_system_scripts);										}


function pp_change(pluginid, permissionid) {
    ajax_call('/data/plugin_perm?'+pluginid+','+permissionid);
}

function pp_activate(pluginid) {
    var o = document.getElementById('cb_'+pluginid);
    if (o) {
	if (o.checked) {
	    ajax_call('/data/plugin_activate?'+pluginid);
	} else {
	    ajax_call('/data/plugin_deactivate?'+pluginid);
	}
    }
}

function update_plugin_permissions(response) {
    var s = document.getElementById('pp_14');
    while (s.length>0) 
	s.remove();
    
    var data = JSON.parse(response);

    for (var i=0; i<data.perms.length; i++) {
	var o = document.createElement('option');
	o.value = data["perms"][i]["id"];
	o.text = data["perms"][i]["name"];
	document.getElementById('pp_14').add(o);
    }
    
    esc_plugin_perms(14, parent.frames[0].plugin_perms[14]);
}


function update_scripts_config(response) {
    var data = JSON.parse(response);

    //document.getElementById('').value = data['matrix'];
    //  document.getElementById('level').value = data['level'];
}


function save_scripts_config() {
    ajax_call('/plugin/scripts_config_set?'+document.getElementById('matrix').value+','+document.getElementById('level').value);
}


function salvo_generated(res) {
    //alert(res);
}

function gen_submit() {
    var str = "";
    str += get_selectactive(document.getElementById("gen_slot"))+"\n";
    str += document.getElementById("gen_name").value+"\n";
    str += document.getElementById("gen_fg").value+"\n";
    str += document.getElementById("gen_bg").value+"\n";
    str += (document.getElementById("gen_opt_xps").checked)?"1\n":"0\n";
    str += (document.getElementById("gen_opt_only_xps").checked)?"1\n":"0\n";
    str += (document.getElementById("gen_opt_unlock").checked)?"1\n":"0\n";
    str += (document.getElementById("gen_opt_locks").checked)?"1\n":"0\n";
    str += (document.getElementById("gen_opt_madi").checked)?"1\n":"0\n";

    post_call("/data/gen_salvo", str, salvo_generated);
}


function scripts_init() {
    esc_plugin_active(14, parent.frames[0].plugin_active[14]);
    ajax_call('/plugin/scripts_config_get', update_scripts_config);
    ajax_call('/data/permissions', update_plugin_permissions);
    init_table();							 
    var d = document.getElementById("gen_slot");
    if (d) {
	for (var i=1; i<=64; i++) {
	    var o = document.createElement("option");
	    o.value = i;
	    o.innerHTML = i;
	    d.appendChild(o);
	}
    }
    
}

