
var rowcnt = 0;

function add_title_row(title) {
    var t = document.getElementById("sfp_data");
    if (t) {
	var row = t.insertRow(t.rows.length);
	row.className = 'title';
	var c = row.insertCell(0);
	c.colSpan = 2;
	c.innerHTML = "<h4>"+title+"</h4>";
    }
    rowcnt = 0;
}


function add_row(c1, c2) {
    var t = document.getElementById("sfp_data");
    if (t) {
	var row = t.insertRow(t.rows.length);
	if (rowcnt++%2==0) {
	    row.style.backgroundColor = "#dddddd";
	} else {
	    row.style.backgroundColor = "#eeeeee";
	}
	var c = row.insertCell(0);
	c.innerHTML = c1;
	c.className = 'head';
	c = row.insertCell(1);
	c.innerHTML = c2;
	c.className = 'data';
    }
}

function add_check(c1, val) {
    var t = document.getElementById("sfp_data");
    if (t) {
	var row = t.insertRow(t.rows.length);
	if (rowcnt++%2==0) {
	    row.style.backgroundColor = "#dddddd";
	} else {
	    row.style.backgroundColor = "#eeeeee";
	}
	var c = row.insertCell(0);
	c.innerHTML = c1;
	c.className = 'head';
	c = row.insertCell(1);
	if (val)
	    c.innerHTML = "<input type='checkbox' checked>";
	else
	    c.innerHTML = "<input type='checkbox'>";
    }
}

function sfp_cb(res) {
    var data = JSON.parse(res);

    if (data["cc"]=="valid") {
	add_title_row("SFP MSA Serial ID");
	add_row("Vendor name:", data["vendor_name"]+" (OUI "+data["vendor_OUI"]+")");
	add_row("Part number:", data["vendor_PN"]+", rev. "+data["vendor_rev"]);
	add_row("Connector:", data["connector"]);
	add_row("Transceiver type:", data["transceiver_type"]);
	add_row("Transceiver codes:", data["transceiver_codes"].replace(/#/g, "<br>"));
	add_row("Encoding:", data["encoding"]);
	add_row("Signalling rate:", data["signalling_rate"]);
	if (data["length_smf"])
	    add_row("Link length single mode fiber:", data["length_smf"]);
	if (data["length_50um"])
	    add_row("Link length 50um OM2 fiber:", data["length_50um"]);
	if (data["length_62.5um"])
	    add_row("Link length 62.5um OM1 fiber:", data["length_62.5um"]);
	if (data["length_om4"])
	    add_row("Link length for 50um OM4 fiber:", data["length_om4"]);
	if (data["length_om3"])
	    add_row("Link length for 50um OM3 fiber:", data["length_om3"]);

	if (data["active_cable_compliance"])
	    add_row("Active Cable compliance", data["active_cable_compliance"].replace(/#/g, "<br>"));
	else if (data["passive_cable_compliance"])
	    add_row("Passive Cable compliance", data["passive_cable_compliance"].replace(/#/g, "<br>"));
	else if (data["wavelength"])
	    add_row("Wavelength:", data["wavelength"]);	
    } else {
	add_row("Check Code", "<b style='color: red;'>Failed</b>");
    }

    add_title_row("Extended Fields");
    if (data["cc_ext"]=="valid") {
	add_check("Paging implemented:", data["paging_implemented"]);
	add_check("Retimer Indicator:", data["retimer_indicator"]);
	add_check("Cooled Transceiver:", data["cooled_transceiver"]);
	add_row("Power Level:", data["power_level"]);
	add_check("Linear RX Output:", data["linear_rx_output"]);
	add_check("RDT implemented:", data["rdt_implemented"]);
	add_check("Tunable Transmitter:", data["Tunable Transmitter"]);
	add_check("Rate Select implemented:", data["rate_select_implemented"]);
	add_check("TX Disable implemented:", data["tx_disable_implemented"]);
	add_check("TX Fault implemented:", data["tx_fault_implemented"]);
	add_check("Signal Detect implemented:", data["signal_detec_implemented"]);
	add_check("Loss-of-Signal implemented:", data["loss_of_signal_implemented"]);
	if (data["extended_signalling_rate"]) {
	    add_row("Signalling Rate:", data["extended_signalling_rate"]);
	    add_row("Rate Range:", data["rate_range"]);
	}
	add_row("Vendor SN:", data["vendor_sn"]);
	add_row("Date Code:", data["date_code"]);
	
	add_check("DMM", data["dmm"]);
	if (data["dmm"]==true) {
	    add_row("Calibration:", data["calibration"]);
	    add_row("Measurement Type:", data["measurement_type"]);
	    add_check("Alarms+Warnings:", data["alarm_warnings"]);
	    add_check("Soft TX Disable:", data["soft_TX_DISABLE"]);
	    add_check("Soft TX Fault:", data["soft_TX_FAULT"]);
	    add_check("Soft RX Lost of Signal:", data["soft_RX_LOS"]);
	    add_check("Soft Rate Select:", data["soft_RATE_SELECT"]);
	    add_check("Application Select Control:", data["application_select_control"]);
	    add_check("Rate Select Control", data["rate_select_control"]);
	}
	add_row("SFF8472 Compliance:", data["SFF8472_compliance"]);
	
    } else {
	add_row("Check Code", "<b style='color: red;'>Failed</b>");
    }

    if (data["dmm"]==true) {
	// [cc_dmi]
	
	if (data["alarm_warnings"]==true) {
	    add_title_row("Alarm and Warning Thresholds");
	    add_row("Temp High Alarm:", data["temp_high_alarm"]);
	    add_row("Temp Low Alarm:", data["temp_low_alarm"]);
	    add_row("Temp High Warning:", data["temp_high_warning"]);
	    add_row("Temp Low Warning:", data["temp_low_warning"]);
	    add_row("Voltage High Alarm:", data["voltage_high_alarm"]);
	    add_row("Voltage Low Alarm:", data["voltage_low_alarm"]);
	    add_row("Voltage High Warning:", data["voltage_high_warning"]);
	    add_row("Voltage Low Warning:", data["voltage_low_warning"]);
	    add_row("Bias High Alarm:", data["bias_high_alarm"]);
	    add_row("Bias Low Alarm:", data["bias_low_alarm"]);
	    add_row("Bias High Warning:", data["bias_high_warning"]);
	    add_row("Bias Low Warning:", data["bias_low_warning"]);
	    add_row("TX Power High Alarm:", data["tx_power_high_alarm"]);
	    add_row("TX Power Low Alarm:", data["tx_power_low_alarm"]);
	    add_row("TX Power High Warning:", data["tx_power_high_warning"]);
	    add_row("TX Power Low Warning:", data["tx_power_low_warning"]);
	    add_row("RX Power High Alarm:", data["rx_power_high_alarm"]);
	    add_row("RX Power Low Alarm:", data["rx_power_low_alarm"]);
	    add_row("RX Power High Warning:", data["rx_power_high_warning"]);
	    add_row("RX Power Low Warning:", data["rx_power_low_warning"]);
	    if (data["laser_temp_high_alarm"]) {		
		add_row("Laser Temp High Alarm:", data["laser_temp_high_alarm"]);
		add_row("Laser Temp Low Alarm:", data["laser_temp_low_alarm"]);
		add_row("Laser Temp High Warning:", data["laser_temp_high_warning"]);
		add_row("Laser Temp Low Warning:", data["laser_temp_low_warning"]);
	    }
	    if (data["tec_current_high_alarm"]) {
		add_row("TEC Current High Alarm:", data["tec_current_high_alarm"]);
		add_row("TEC Current Low Alarm:", data["tec_current_low_alarm"]);
		add_row("TEC Current High Warning:", data["tec_current_high_warning"]);
		add_row("TEC Current Low Warning:", data["tec_current_low_warning"]);
	    }
	}

	if (data["calibration"]=="external") {
	    add_title_row("Calibration Constants");
	    add_row("Rx_PWR(4)", data["cal_rx_pwr_4"]);
	    add_row("Rx_PWR(3)", data["cal_rx_pwr_3"]);
	    add_row("Rx_PWR(2)", data["cal_rx_pwr_2"]);
	    add_row("Rx_PWR(1)", data["cal_rx_pwr_1"]);
	    add_row("Rx_PWR(0)", data["cal_rx_pwr_0"]);
	    add_row("Tx_I(Slope)", data["cal_tx_i_slope"]);
	    add_row("Tx_I(Offset)", data["cal_tx_i_offset"]);
	    add_row("Tx_PWR(Slope)", data["cal_tx_pwr_slope"]);
	    add_row("Tx_PWR(Offset)", data["cal_tx_pwr_offset"]);
	    add_row("T(Slope)", data["cal_t_slope"]);
	    add_row("T(Offset)", data["cal_t_offset"]);
	    add_row("V(Slope)", data["cal_t_slope"]);
	    add_row("V(Offset)", data["cal_t_offset"]);
	}

	add_title_row("Real-Time Diagnostic and Control Registers");
	add_row("", "(these values have been sampled once upon module detection)");
	add_row("Module Temperature:", data["module_temperature"]);
	add_row("Supply Voltage:", data["supply_voltage"]);
	add_row("Bias Current:", data["bias_current"]);
	add_row("TX Power:", data["tx_power"]);
	add_row("RX Power:", data["rx_power"]);

	if (data["laser_temp"])
	    add_row("Laser Temperature:", data["laser_temp"]);
	if (data["tec_current"])
	    add_row("TEC Current:", data["tec_current"]);

	add_row("TX Disable State:", data["tx_disable_state"]);
	add_row("Soft TX Disable:", data["soft_tx_disable"]);
	add_row("RS 1 State:", data["rs_1_state"]);
	add_row("Rate Select State:", data["rate_select_state"]);
	add_row("Soft Rate Select State:", data["soft_rate_select_state"]);
	add_row("TX Fault State:", data["tx_fault_state"]);
	add_row("RX LoS State:", data["rx_los_state"]);
	add_row("Data Ready Bar State:", data["data_ready_bar_state"]);	
    }	
}


function sfp_init() {
    var id = location.search.substr(1);
    ajax_call("/data/sfp?"+id, sfp_cb);
}
