/**
 * WCK configuration
 * @copyright D.O.TEC
 * @author Florian Faber, florian.faber@directout.eu
 * @version 3 (17.06.2014)
 *          - added 96k frame follow
 * @version 2 (28.05.2012)
 **/

var labels=false;

function esc_96k_follow(val) {
	document.getElementById('96k_follow').checked = (val==1);
}

function esc_term(level) {
	document.getElementById('term').checked = (level==1);
}

function ess_video_mode(mode) {
	update_video_status();
}


var master_source_selected = 0;

function update_master_source_led(id, src, selsrc, label) {
		// active?
		if ((src==selsrc) && !master_source_selected) {
				label.style.fontWeight = "bold";
				master_source_selected = 1;
		} else {
				label.style.fontWeight = "normal";
		}

		if (selsrc==18) // video input
				selsrc = 17;
		
		// sync status
		if ((selsrc==19) || (selsrc==20)) {
				// internal clock, always valid
				document.getElementById('wck'+id).src = "/img/status_led_3.png";
		} else if (selsrc==-1) {
				// disabled
				document.getElementById('wck'+id).src = "/img/status_led_0.png";
		} else if (parent.frames[0].status_port_sync[selsrc]==3) {
				document.getElementById('wck'+id).src = "/img/status_led_3.png";
		} else if (parent.frames[0].status_port_sync[selsrc]==1) {
				document.getElementById('wck'+id).src = "/img/status_led_1.gif";
		} else {
				document.getElementById('wck'+id).src = "/img/status_led_2.png";
		}
}

function ess_master_source(src) {
		master_source_selected = 0;
		
		update_master_source_led(0, src, get_selectactive(document.getElementById("ref_clock_17")), document.getElementById("label_master_source"));
		/*drop down lists of fallback are 1-based indexed because of "Disabled" being index 0. This needs to be compensated here when looking up the matching sync status
		-> parseInt(get_selectactive(document.getElementById("ref_fallback0"))-1) */
		update_master_source_led(1, src, parseInt(get_selectactive(document.getElementById("ref_fallback0"))-1), document.getElementById("label_master_fallback0")); 
		update_master_source_led(2, src, parseInt(get_selectactive(document.getElementById("ref_fallback1"))-1), document.getElementById("label_master_fallback1"));
}


function update_clock_elems(port) {
	document.getElementById('ref_clock_'+port).disabled = parent.frames[0].config_master_enable_clock || 
		(parent.frames[0].config_port_follow[port]!=port) || 
		(parent.frames[0].permissions.clocks[port]==0);

	document.getElementById('wck_mul_'+port).disabled = (parent.frames[0].config_master_enable_fs ||
																											 (parent.frames[0].config_port_follow[port]!=port) || (parent.frames[0].permissions.port_mul[port]==0)) || ((parent.frames[0].config_96k_follow>0) && (parent.frames[0].status_port_frame[port]==96));
}


function ess_port_frame(port, frame) {
		update_clock_elems(port);
}


function ess_sync(port, sync, t) {
		ess_master_source(parent.frames[0].status_master_source);
}

function update_master_freq() {
	var freq;
	//var port = parent.frames[0].config_poly_source[17];
	var port = parent.frames[0].status_master_source;

	if (port<19)
		freq = parent.frames[0].status_port_freq[port];

		else if ((port==19) || (port==21))
				freq = 44100;
		else if ((port==20) || (port==22))
				freq = 48000;

	document.getElementById("master_freq").innerHTML = freq+" Hz";	
}


function ess_freq(port, freq) {
	var o;
	
	switch(port) {
	case 16: // WCK input
		update_wck_status();
		break;
		
	case 17: // Video 44.1kHz
	case 18: // Video 48kHz
		update_video_status();
		break;
		
	case 19: // WCK output
		document.getElementById("wck_freq").innerHTML = freq+" Hz";
		break;
		
	default: // Input ports
		o = document.getElementById("freq_"+port);
		if (o) {
			if (freq>0) {
				o.style.opacity = 1;
				o.innerHTML = freq+" Hz";
			} else {
				o.innerHTML = "[no signal]";
				o.style.opacity = 0.5;
			}
		}
	}
	
	if (port==parent.frames[0].status_master_source)
		update_master_freq();
}


function esc_poly_source(port, source) {
	set_selectactive(document.getElementById("ref_clock_"+port), source);
		if (port==17) {
				update_master_freq();
				update_fallbacks();
		}
	update_clock_status();

		if (port==17)
				ess_master_source(parent.frames[0].status_master_source);
}


function update_masterfs_96k_hint() {
		document.getElementById("masterfs_96k_hint").style.display = ((parent.frames[0].config_master_enable_fs==0) || (parent.frames[0].config_wck_mul[17]==1))?"none":"block";
}

function esc_wck_mul(port, mul) {
	var s = document.getElementById('wck_mul_'+port);
	if (s)
		set_selectactive(s, mul);

		update_clock_status();

  if (port==17) {
		update_masterfs_96k_hint();
	}
}


function esc_port_follow(port, follow) {
	var s = document.getElementById('follow_port_'+port);
	var i;

	set_selectactive(s, follow);

	update_clock_elems(port);
	
	//document.getElementById('wck_mul_'+port).disabled = parent.frames[0].config_master_enable_fs || (port!=follow) || (parent.frames[0].permissions.port_mul[port]==0);

	//document.getElementById('ref_clock_'+port).disabled = parent.frames[0].config_master_enable_clock || (port!=follow) || (parent.frames[0].permissions.clocks[port]==0);

	for (i=0; i<17; i++) {
		s = document.getElementById('follow_port_'+i);
		if (i!=port)
			s.children[port+2].disabled = (port!=follow);
	}

	if ((follow<17) && (port!=follow))
		document.getElementById('follow_port_'+follow).is_followed = true;

	for (var p=0; p<17; p++) {
		for (i=0; i<17; i++) {
			if (i==p)
				continue;
			if (parent.frames[0].config_port_follow[i]==p)
				break;
		}
		if (i==17)
			document.getElementById('follow_port_'+p).is_followed = false;
	}

	update_clock_status();
}


function esc_master_enable_clock(enable) {
	document.getElementById('cb_master_enable_clock').checked = enable;

	for (var i=0; i<17; i++)
		update_clock_elems(i);
	//document.getElementById('ref_clock_'+i).disabled = enable || (parent.frames[0].config_port_follow[i]!=i) || (parent.frames[0].permissions.clocks[i]==0);

	update_clock_status();
}


function esc_master_enable_fs(enable) {
	document.getElementById('cb_master_enable_fs').checked = enable;

	for (var i=0; i<17; i++) {
		update_clock_elems(i);
		//document.getElementById('wck_mul_'+i).disabled = enable || (parent.frames[0].config_port_follow[i]!=i) || (parent.frames[0].permissions.port_mul[i]==0);
	}
		update_clock_status();

		update_masterfs_96k_hint();
}


function update_fallbacks() {
		/*
		 * wenn eine clock source nicht un-syncen kann (z.B. Intern), dann
		 * darunterliegende Optionen deaktivieren
		 */
		var f0 = document.getElementById("ref_fallback0");
		var f1 = document.getElementById("ref_fallback1");

		if (parent.frames[0].config_poly_source[17]>18) {
				f0.disabled = true;
				f1.disabled = true;
		} else if (parent.frames[0].config_master_fallback[0]>19) {
				f0.disabled = false;
				f1.disabled = true;
		} else {
				f0.disabled = false;
				f1.disabled = false;
		}
}


function esc_master_fallback(id, src) {
		var o = document.getElementById("ref_fallback"+id);
		if (o) {
			if (id == 1) { //if there was something configured for Secondary Fallback -> disable it for good!
				send_cmd("fallback?1,0");  
			}
				set_selectactive(o, src);
		}
		update_fallbacks();
		ess_master_source(parent.frames[0].status_master_source);
}


function update_clock_status() {
	for (var i=0; i<17; i++) {
		var source = document.getElementById("source_"+i);
		var fs = document.getElementById("fs_"+i);
		var follow = document.getElementById("follow_port_"+i);

		var eff_source = parent.frames[0].get_effective_source(i);
		if (eff_source<16) {
			if (labels)
				source.innerHTML = parent.frames[0].labels_input_ports[eff_source];
			else
				source.innerHTML = parent.frames[0].wck_sources[eff_source];
		} else {
			source.innerHTML = parent.frames[0].wck_sources[eff_source];
		}

		fs.innerHTML = parent.frames[0].fs_strings[parent.frames[0].get_effective_mul(i)];

		if (parent.frames[0].permissions.port_follow[i]==0) {
			follow.disabled = true;

		}	else if (parent.frames[0].config_master_enable_clock &&
							 parent.frames[0].config_master_enable_fs) {
			follow.disabled = true;
			
		} else {
			follow.disabled = follow.is_followed;
		}
	}

}


function update_wck_status() {
		str = "";
		if (parent.frames[0].status_wck_mode==1) {
				str += "AES11 signal, ";
		}
	str += parent.frames[0].status_sync_str(16);
	var o = document.getElementById("wck_status");
	if (3 != parent.frames[0].status_port_sync[16])
		o.style.color = 'red';
	else 
		o.style.color = 'black';

	//if (0 != parent.frames[0].status_port_sync[16])
	var f = parent.frames[0].status_port_freq[16];
	str += "<br>Frequency: "+f+"Hz";
	if ((f<30000) ||
			((f>54000) && (f<60000)) ||
			((f>108000) && (f<120000)) ||
			(f>208000)) {
		str += ", <span style='color: red;'>out of safe range</span>";
	}
		

	o.innerHTML = str;
}


function update_video_status() {
	str = parent.frames[0].status_sync_str(17);
	
	var o = document.getElementById("video_status");
	if (3 != parent.frames[0].status_port_sync[17])
		o.style.color = 'red';
	else {
		o.style.color = 'black';
	}
	if (parent.frames[0].status_port_sync[17]>0) {
		str += "<br>Format: "+parent.frames[0].status_video_mode;
		str += "<br>Derived clocks: "+parent.frames[0].status_port_freq[17]+"Hz / "+parent.frames[0].status_port_freq[18]+"Hz";
	}
	o.innerHTML = str;
}


function update_status() {
	update_wck_status();
	update_video_status();
	
	window.setTimeout("update_status()", 1000);
}


function update_labels() {
	var t = document.getElementById('polysync');
	var cs = Array(20);
	var fs = Array(17);
	var str_label, str_combo;

	for (var i=0; i<18; i++) 
		cs[i] = document.getElementById('ref_clock_'+i);
	
	for (var i=0; i<2; i++) 
	    cs[18+i] = document.getElementById('ref_fallback'+i);
    
	for (var i=0; i<17; i++) 
		fs[i] = document.getElementById('follow_port_'+i);

	for (var i=0; i<16; i++) {
		if (labels) {
			str_label = "<div style='color: #"+parent.frames[0].labels_output_ports_fg[i]+"; background-color: #"+parent.frames[0].labels_output_ports_bg[i]+"; padding: 5px; font-size: 0.8em;'>"+parent.frames[0].labels_output_ports[i]+"</div>";
			str_combo = parent.frames[0].labels_input_ports[i];
		} else {
			str_label = "Port "+(i+1);
			str_combo = str_label;
		}

		t.rows[i+2].children[0].innerHTML = str_label;

		for (var j=0; j<20; j++) {
			//change to 1-based index in case of ref_fallback_x to not override "Disabled" state on index 0
			if (j==18 || j==19) {
				cs[j].children[i+1].innerHTML = str_combo;
			}
			else cs[j].children[i].innerHTML = str_combo;
		}

		for (var j=0; j<17; j++) {
			fs[j].children[i+2].innerHTML = str_combo;
		}
	}
}


function permissions_updated() {
	document.getElementById("label_master_source").className = (parent.frames[0].permissions.clocks[17]==0)?"disabled":"";
	document.getElementById("ref_clock_17").disabled = (parent.frames[0].permissions.clocks[17]==0);

	document.getElementById("label_master_clock").className = (parent.frames[0].permissions.clocks[17]==0)?"disabled":"";
	document.getElementById("cb_master_enable_clock").disabled = (parent.frames[0].permissions.clocks[17]==0);

	document.getElementById("label_wck_mul_17").className = (parent.frames[0].permissions.clocks[17]==0)?"disabled":"";
	document.getElementById("wck_mul_17").disabled = (parent.frames[0].permissions.clocks[17]==0);

	document.getElementById("label_master_fs").className = (parent.frames[0].permissions.clocks[17]==0)?"disabled":"";
	document.getElementById("cb_master_enable_fs").disabled = (parent.frames[0].permissions.clocks[17]==0);

		document.getElementById("label_96k_follow").className = (parent.frames[0].permissions.config_86k_follow==0)?"disabled":"";
		document.getElementById("96k_follow").disabled = (parent.frames[0].permissions.config_86k_follow==0);

	document.getElementById("label_term").className = (parent.frames[0].permissions.config_device_term==0)?"disabled":"";
	document.getElementById("term").disabled = (parent.frames[0].permissions.config_device_term==0);

	document.getElementById("label_wck_source").className = (parent.frames[0].permissions.clocks[16]==0)?"disabled":"";
	document.getElementById("ref_clock_16").disabled = (parent.frames[0].permissions.clocks[16]==0);

	document.getElementById("label_mul_16").className = (parent.frames[0].permissions.clocks[16]==0)?"disabled":"";
	document.getElementById("wck_mul_16").disabled = (parent.frames[0].permissions.clocks[16]==0);

	document.getElementById("label_follow_16").className = (parent.frames[0].permissions.port_follow[16]==0)?"disabled":"";
	document.getElementById("follow_port_16").disabled = (parent.frames[0].permissions.port_follow[16]==0);

	update_clock_status();

	for (var i=0; i<17; i++)
		update_clock_elems(i);
}


function show_labels(v) {
  if (typeof(v)=='string') {
    v = parseInt(v, 10);
    var bla=typeof(v);
    if ((typeof(v)!='number') || isNaN(v))
      v = 0;
    set_cycle_button(document.getElementById("show_labels"), v);
  } else if (labels != v) {
    post_call('/wwwdata?show_labels', v, false);
  }

  labels = v;

	update_labels();
	update_clock_status();
}


function cb_keydown(e) {
  switch(e.keyCode) {
  case 68:
    push_cycle_button(document.getElementById("show_labels"));    
    e.preventDefault();
    break;
  }
}


function wck_init() {
	var t = document.getElementById('polysync');
	var row;

	for (i=0; i<16; i++) {
			row = t.insertRow(i+2);
		
		var td = row.insertCell(0);
		td.innerHTML = "Port "+(i+1);
		
		td = row.insertCell(1);
		td.innerHTML = '<select id="ref_clock_'+i+'" onchange="send_cmd(\'poly_source?'+i+',\'+get_selectactive(this));" style="width: 100%;"><option value="0">Port 1</option><option value="1">Port 2</option><option value="2">Port 3</option><option value="3">Port 4</option><option value="4">Port 5</option><option value="5">Port 6</option><option value="6">Port 7</option><option value="7">Port 8</option><option value="8">Port 9</option><option value="9">Port 10</option><option value="10">Port 11</option><option value="11">Port 12</option><option value="12">Port 13</option><option value="13">Port 14</option><option value="14">Port 15</option><option value="15">Port 16</option><option value="16">WCK Input</option><option value="17">Video 44.1kHz</option><option value="18">Video 48kHz</option><option value="19">Internal 44.1kHz</option><option value="20">Internal 48kHz</option></select>';

		td = row.insertCell(2);
		td.style.textAlign = 'center';
		td.innerHTML = '<select id="wck_mul_'+i+'" onchange="send_cmd(\'wck_mul?'+i+',\'+get_selectactive(this));"><option value="0">1FS</option><option value="1">2FS</option><option value="2">4FS</option></select>';

		td = row.insertCell(3);
		td.innerHTML = '<select id="follow_port_'+i+'" onchange="send_cmd(\'port_follow?'+i+',\'+get_selectactive(this));" style="width: 100%;"><option value="16">don\'t follow</option><option value="17">Master clock</option><option value="0">Port 1</option><option value="1">Port 2</option><option value="2">Port 3</option><option value="3">Port 4</option><option value="4">Port 5</option><option value="5">Port 6</option><option value="6">Port 7</option><option value="7">Port 8</option><option value="8">Port 9</option><option value="9">Port 10</option><option value="10">Port 11</option><option value="11">Port 12</option><option value="12">Port 13</option><option value="13">Port 14</option><option value="14">Port 15</option><option value="15">Port 16</option><option value="16">Word Clock</option></select>';
		td.style.paddingRight = "15px";
		td.children[0].children[0].value = i;
		td.children[0].children[i+2].disabled = true;
		
		td = row.insertCell(4);
		td.style.textAlign = 'center';
		td.className = 'status';
		td.id = 'source_'+i;

		td = row.insertCell(5);
		td.style.textAlign = 'center';
		td.className = 'status';
		td.id = 'fs_'+i;		

		td = row.insertCell(6);
		td.style.textAlign = 'right';
		td.className = 'status';
		td.id = 'freq_'+i;
	}

	esc_master_enable_clock(parent.frames[0].config_master_enable_clock);
	esc_master_enable_fs(parent.frames[0].config_master_enable_fs);

		esc_master_fallback(0, parent.frames[0].config_master_fallback[0]);
		esc_master_fallback(1, parent.frames[0].config_master_fallback[1]);
		
	for (i=0; i<18; i++) {
		esc_poly_source(i, parent.frames[0].config_poly_source[i]);
		esc_wck_mul(i, parent.frames[0].config_wck_mul[i]);
		ess_freq(i, parent.frames[0].status_port_freq[i]);
	}

	for (i=0; i<17; i++)
		esc_port_follow(i, parent.frames[0].config_port_follow[i]);

  esc_96k_follow(parent.frames[0].config_96k_follow);
	esc_term(parent.frames[0].config_term);

	document.getElementById("wck_freq").innerHTML = parent.frames[0].status_port_freq[19]+" Hz";
	
	update_status();

	ajax_call('/wwwdata?show_labels', show_labels);
	init_cycle_button(document.getElementById("show_labels"), ['System Labels', 'User Labels'], show_labels);  
	window.onkeydown = cb_keydown;

		ess_master_source(parent.frames[0].status_master_source);
		
	permissions_updated();
}
